@echo off &setlocal DisableDelayedExpansion
set "infile=test.txt"
set "outfile=test.pdf"
set "tabwidth=8"


set "tab=	"
set "spcs=                                                                                                    "
for /f %%a in ('copy /z "%~f0" nul') do set "cr=%%a"
for /f "tokens=1,2*" %%a in ('reg query "HKCU\Control Panel\International"^|findstr /i "\<[is]Date\>"') do set "%%a=%%c"
for /f "tokens=1-6 delims=:.,%sDate%" %%a in ("%date:* =%,%time: =0%") do (
  if %iDate%==0 (set mm=%%a&set dd=%%b&set yy=%%c) else if %iDate%==1 (set dd=%%a&set mm=%%b&set yy=%%c) else (set yy=%%a&set mm=%%b&set dd=%%c)
  (set h=%%d&set m=%%e&set s=%%f)
)
if 1%yy% LSS 200 if 1%yy% LSS 170 (set yy=20%yy%) else (set yy=19%yy%)


>"%outfile%" echo(%%PDF-1.1

for %%i in ("%outfile%") do set "objpos[1]=%%~zi"
>>"%outfile%" (
  echo(1 0 obj
  echo(^<^<
  echo(/CreationDate ^(D:%yy%%mm%%dd%%h%%m%%s%^)
  echo(/Producer ^(text2pdf.bat^)
  echo(/Title ^(text2pdf^)
  echo(^>^>
  echo(endobj
)

for %%i in ("%outfile%") do set "objpos[2]=%%~zi"
>>"%outfile%" (
  echo(2 0 obj
  echo(^<^<
  echo(/Type /Catalog
  echo(/Pages 3 0 R
  echo(^>^>
  echo(endobj
)

for %%i in ("%outfile%") do set "objpos[4]=%%~zi"
>>"%outfile%" (
  echo(4 0 obj
  echo(^<^<
  echo(/Type /Font
  echo(/Subtype /Type1
  echo(/Name /F1
  echo(/BaseFont /Courier
  echo(/Encoding /WinAnsiEncoding
  echo(^>^>
  echo(endobj
)

for %%i in ("%outfile%") do set "objpos[5]=%%~zi"
>>"%outfile%" (
  echo(5 0 obj
  echo(^<^<
  echo(/Font ^<^< /F1 4 0 R ^>^>
  echo(/ProcSet [ /PDF /Text ]
  echo(^>^>
  echo(endobj
)

for %%i in ("%outfile%") do set "objpos[6]=%%~zi"
>>"%outfile%" (
  echo(6 0 obj
  echo(^<^<
  echo(/Type /Page
  echo(/Parent 3 0 R
  echo(/Resources 5 0 R
  echo(/Contents 7 0 R
  echo(^>^>
  echo(endobj
)

for %%i in ("%outfile%") do set "objpos[7]=%%~zi"
>>"%outfile%" (
  echo(7 0 obj
  echo(^<^<
  echo(/Length 8 0 R
  echo(^>^>
  echo(stream
)

for %%i in ("%outfile%") do set "streampos=%%~zi"
>>"%outfile%" (
  echo(BT
  echo(/F1 10 Tf
  echo(1 0 0 1 50 752 Tm
  echo(12 TL
)
setlocal EnableDelayedExpansion
<"!infile!" >>"!outfile!" (
  for /f %%i in ('type "!infile!"^|find /c /v ""') do for /l %%j in (1 1 %%i) do (
    set "ln=" &set /p "ln="
    if defined ln call :proc_line
    echo(^(!ln!^)'
  )
  echo(^(^)'
)
endlocal
>>"%outfile%" echo(ET

for %%i in ("%outfile%") do set /a "streamlen=%%~zi-streampos"
>>"%outfile%" (
  echo(endstream
  echo(endobj
)

for %%i in ("%outfile%") do set "objpos[8]=%%~zi"
>>"%outfile%" (
  echo(8 0 obj
  echo(%streamlen%
  echo(endobj
)

for %%i in ("%outfile%") do set "objpos[3]=%%~zi"
>>"%outfile%" (
  echo(3 0 obj
  echo(^<^<
  echo(/Type /Pages
  echo(/Count 1
  echo(/MediaBox [ 0 0 612 792 ]
  echo(/Kids [ 6 0 R ]
  echo(^>^>
  echo(endobj
)

for %%i in ("%outfile%") do set "xrefpos=%%~zi"
setlocal EnableDelayedExpansion
>>"!outfile!" (
  echo(xref
  echo(0 9
  <nul set /p "=0000000000 65535 f !cr!"
  for /l %%i in (1 1 8) do (
    set "pos=0000000000!objpos[%%i]!"
    <nul set /p "=!pos:~-10! 00000 n !cr!"
  )
  echo(trailer
  echo(^<^<
  echo(/Size 9
  echo(/Root 2 0 R
  echo(/Info 1 0 R
  echo(^>^>
  echo(startxref
  echo(!xrefpos!
  echo(%%%%EOF
  echo(
)
endlocal
pause
exit /b

:proc_line
for /f "tokens=1* delims=%tab%" %%i in ("X!ln!") do if "%%j" neq "" (
  set "str=X!ln!"
  set "len=0"
  for /l %%i in (12 -1 0) do (
    set /a "len|=1<<%%i"
    for %%j in (!len!) do if "!str:~%%j,1!"=="" set /a "len&=~1<<%%i"
  )
  set /a "len-=1"
  call :tab_recur 0
)
for %%i in ("\=\\" "(=\(" ")=\)") do set "ln=!ln:%%~i!"
exit /b

:tab_recur
if %1 lss !len! (
  set /a "nxt=%1+1"
  if "!ln:~%1,1!"=="%tab%" (
    set /a "d=0-(%1 %% tabwidth)+tabwidth, e=nxt, nxt+=d-1, len+=d-1"
    for /f "tokens=1,2" %%d in ("!d! !e!") do set "ln=!ln:~0,%1!!spcs:~-%%d!!ln:~%%e!"
  )
  call :tab_recur !nxt!
)
exit /b
